#include <Arduino_FreeRTOS.h>
#include <semphr.h>  // add the FreeRTOS functions for Semaphores (or Flags).

bool GO = false;


bool Derecha=false;
bool Izquierda=0;


#define M1Delante 2
#define M1Atras 3

#define M2Delante 4
#define M2Atras 5

#define SensorTrasero 8

#define SensorDerecho 9
#define SensorIzquierdo 10



TaskHandle_t xd;
SemaphoreHandle_t xSerialSemaphore;

void EncontrarEnemigo( void *pvParameters );
void SensorTras( void *pvParameters );
void SensoresLateral( void *pvParameters );

void MotoresDelante();
void MotoresGirarIzquierda();
void MotoresGirarDerecha();
void EsquivarAtras();

void setup() {

  

  

   

  // initialize serial communication at 9600 bits per second:
  Serial.begin(9600);

  pinMode(M1Delante,OUTPUT);
  pinMode(M1Atras,OUTPUT);

  pinMode(M2Delante,OUTPUT);
  pinMode(M2Atras,OUTPUT);

  pinMode(SensorTrasero,INPUT);
  pinMode(SensorDerecho,INPUT);
  pinMode(SensorIzquierdo,INPUT);

  pinMode(7,INPUT);


  
  while (!Serial) {
    ; // wait for serial port to connect. Needed for native USB, on LEONARDO, MICRO, YUN, and other 32u4 based boards.
  }

  
  if ( xSerialSemaphore == NULL )  // Check to confirm that the Serial Semaphore has not already been created.
  {
    xSerialSemaphore = xSemaphoreCreateMutex();  // Create a mutex semaphore we will use to manage the Serial Port
    if ( ( xSerialSemaphore ) != NULL )
      xSemaphoreGive( ( xSerialSemaphore ) );  // Make the Serial Port available for use, by "Giving" the Semaphore.
  }

  

  // Now set up two Tasks to run independently.
  xTaskCreate(
    EncontrarEnemigo
    ,  "DigitalRead"  // A name just for humans
    ,  128  // This stack size can be checked & adjusted by reading the Stack Highwater
    ,  NULL //Parameters for the task
    ,  2  // Priority, with 3 (configMAX_PRIORITIES - 1) being the highest, and 0 being the lowest.
    ,  &xd ); //Task Handle

  xTaskCreate(
    SensorTras
    ,  "AnalogRead" // A name just for humans
    ,  128  // Stack size
    ,  NULL //Parameters for the task
    ,  0  // Priority
    ,  NULL ); //Task Handle

    xTaskCreate(
    SensoresLateral
    ,  "AnalogRead" // A name just for humans
    ,  128  // Stack size
    ,  NULL //Parameters for the task
    ,  1  // Priority
    ,  NULL ); //Task Handle

}

void loop()
{
  
}

/*--------------------------------------------------*/
/*---------------------- Tasks ---------------------*/
/*--------------------------------------------------*/

void EncontrarEnemigo( void *pvParameters __attribute__((unused)) )  // This is a Task.
{
  /*
    DigitalReadSerial
    Reads a digital input on pin 2, prints the result to the serial monitor

    This example code is in the public domain.
  */

  

  for (;;) // A Task shall never return or exit.
  {


float suma = 0;

if(GO==false)
    {
      bool arranque = digitalRead(7);
      
      if(arranque)
      {
        Izquierda=true;
        
        GO=true;
      }
    }

    for(int i=0;i<50;i++)
  {
    suma=suma+analogRead(A0);
  } 

    float adc=suma/50;
  float d = 17569.7 * pow(adc, -1.2062);

    if(d<70&&GO==true)
    {
      MotoresDelante();
    }
    else
    {
      if(Derecha)
      {
        MotoresGirarDerecha();
      }
      else if(Izquierda)
      {
        MotoresGirarIzquierda(); 
      }
    }

    
    
    if ( xSemaphoreTake( xSerialSemaphore, ( TickType_t ) 5 ) == pdTRUE )
    {
      
     Serial.println(d);

      xSemaphoreGive( xSerialSemaphore ); // Now free or "Give" the Serial Port for others.
    }

    vTaskDelay(1);  // one tick delay (15ms) in between reads for stability
  }
}

void SensorTras( void *pvParameters __attribute__((unused)) )  // This is a Task.
{


  for (;;)
  {

String estado="Normal";

  

    if(digitalRead(SensorTrasero))
    {
  
      EsquivarAtras();
  
      estado="Esquivando";
      Derecha=true;
      Izquierda=false;
    }
   
    if ( xSemaphoreTake( xSerialSemaphore, ( TickType_t ) 5 ) == pdTRUE )
    {

      Serial.println(estado);

      xSemaphoreGive( xSerialSemaphore ); // Now free or "Give" the Serial Port for others.
    }

    vTaskDelay(1);  // one tick delay (15ms) in between reads for stability
  }
}

void SensoresLateral( void *pvParameters __attribute__((unused)) )  // This is a Task.
{

  for (;;)
  {

    if(digitalRead(SensorIzquierdo))
    {
      Derecha=true;
      Izquierda=false;
    }
    else if(digitalRead(SensorDerecho))
    {
      Derecha=false;
      Izquierda=true;
    }
    
    if ( xSemaphoreTake( xSerialSemaphore, ( TickType_t ) 5 ) == pdTRUE )
    {
      

      xSemaphoreGive( xSerialSemaphore ); // Now free or "Give" the Serial Port for others.
    }

    vTaskDelay(1);  // one tick delay (15ms) in between reads for stability
  }
}

void MotoresDelante()
{
  digitalWrite(M1Delante,HIGH);
  digitalWrite(M1Atras,LOW);

  digitalWrite(M2Delante,HIGH);
  digitalWrite(M2Atras,LOW);
  
}

void MotoresGirarIzquierda()
{
  digitalWrite(M1Delante,LOW);
  digitalWrite(M1Atras,HIGH);

  digitalWrite(M2Delante,HIGH);
  digitalWrite(M2Atras,LOW);
  
}

void EsquivarAtras()
{
  vTaskSuspend( xd );
  digitalWrite(M1Delante,HIGH);
  digitalWrite(M1Atras,LOW);
  
  digitalWrite(M2Delante,LOW);
  digitalWrite(M2Atras,HIGH);

  delay(500);

  digitalWrite(M1Delante,LOW);
  digitalWrite(M1Atras,LOW);

  delay(500);

  vTaskResume( xd );
}

void MotoresGirarDerecha()
{
  digitalWrite(M1Delante,HIGH);
  digitalWrite(M1Atras,LOW);

  digitalWrite(M2Delante,LOW);
  digitalWrite(M2Atras,HIGH);
  
}
